1000 REMark *** Turn on archiving for selected files on hard disc ***
1010 :
1020 WHEN_ERROR 0
1030   CONTINUE
1040 END_WHEN
1050 :
1060 init
1070 PRINT #1,'Which device : ';
1080 device$ = EDIT$(#1, device$, 5)
1090 check_dir device$
1100 :
1110 :
1120 DEFine PROCedure check_dir (d$)
1130   LOCal name_len%, curr_d$(40), curr_f$(41), entry$(64), loop
1140   LOCal ch%, qdos, err_loop, error_code%, loop_yn
1150   :
1160   REMark ** Process each directory entry in turn, ignoring nulls,  **
1170   REMark ** if a sub-directory is found, process it if required.   **
1180   :
1190   curr_d$ = d$
1200   PRINT
1210   CURSOR_ON #1 !
1220   PRINT 'New Directory : ' & curr_d$
1230   all% = 0:               REMark ** Turn it off for each directory **
1240   REPeat err_loop
1250      qdos = FOPEN_DIRECTORY(curr_d$)
1260      IF qdos < 0
1270         FORCE_ERROR qdos, 'Cannot open directory on ' & curr_d$
1280      ELSE 
1290         EXIT err_loop
1300      END IF 
1310   END REPeat err_loop
1320   REPeat loop
1330     IF END_OF_DIRECTORY(qdos) THEN EXIT loop: END IF 
1340     IF INKEY$(#1, 5) = CHR$(27)
1350        aborted = 1:    REMark ** ESC pressed during 'A' processing **
1360        EXIT loop
1370     END IF 
1380     entry$ = FREAD_DIRECTORY$(qdos)
1390     IF entry$ = '' THEN NEXT loop: END IF 
1400     name_len% = CODE(entry$(15)) * 256 + CODE(entry$(16))
1410     IF NOT (name_len%) THEN NEXT loop: END IF 
1420     curr_f$ = device$ & entry$(17 TO (17 + name_len% - 1))
1430     IF CODE(entry$(6)) = 255
1440        :
1450        REMark ** Sub-directory **
1460        :
1470        check_dir (curr_f$)
1480        IF aborted THEN EXIT loop: END IF 
1490        PRINT 'Old directory : ' & curr_d$
1500     ELSE 
1510        :
1520        REMark ** Data or program file **
1530        :
1540        OPEN #3,curr_f$
1550        IF all%
1560           PRINT '   ' & curr_f$
1570           SET_FUPDT #3, today
1580        ELSE 
1590           PRINT '   Turn ON ' & curr_f$ & ' Y,N,A,Q ? ';
1600           REPeat loop_yn
1610             yn$ = INKEY$(#1, -1)
1620             IF yn$ = '' THEN NEXT loop_yn: END IF 
1630             IF yn$ INSTR 'YNAQ' THEN EXIT loop_yn: END IF 
1640           END REPeat loop_yn
1650           PRINT yn$
1660           IF yn$ == 'Y' OR yn$ == 'A'
1670              SET_FUPDT #3, today
1680              IF yn$ == 'A'
1690                 all% = 1
1700              END IF 
1710           END IF 
1720        END IF 
1730        CLOSE #3
1740        IF yn$ == 'Q'
1750           aborted = 1
1760           EXIT loop
1770        END IF 
1780     END IF 
1790   END REPeat loop
1800   CLOSE_DIRECTORY (qdos)
1810   CURSOR_OFF #1
1820 END DEFine check_dir
1830 :
1840 :
1850 DEFine PROCedure FORCE_ERROR (error_code, text$)
1860   PRINT #1, 'Error ' & error_code
1870   PRINT #1, text$
1880   PRINT_ERROR$ #1, error_code
1890   STOP
1900 END DEFine FORCE_ERROR
1910 :
1920 :
1930 DEFine PROCedure init
1940   DATA_AREA 6
1950   today = DATE:         REMark ** Set last backup date to today    **
1960   aborted = 0:          REMark ** If ESC pressed during processing **
1970   all% = 0:             REMark ** Do all files in directory        **
1980   DIM yn$(1)
1990   DIM device$(5)
2000   device$ = 'win1_'
2010   IF COMPILED
2020      OPEN #2, 'scr_512x256a0x0'
2030      PAPER #2, 6: CLS #2
2040      WINDOW #2, 448, 22, 32, 16
2050      INK #2, 6: PAPER #2, 2: CLS #2: BORDER #2, 1, 1
2060      OPEN #1, 'con_448x178a32x38'
2070      INK #1, 0: PAPER #1, 4: CLS #1: BORDER #1, 1, 1
2080      CSIZE #2, 0, 1
2090      PRINT #2, '                               WinBack ON';
2100      CSIZE #2, 0, 0
2110   END IF 
2120   CURSOR_ON #1 !
2130 END DEFine 
